/*  www.sgm.siedlce.pl

Sterowanie dwoma napedami "continious servo"
w trojkolowym modelu "RcBot", dwa kanaly z odbiornika RC
(oznacznenia dla Mode2): kan 2 (lewo-prawo) i kan3 (przod-tyl),
suma kan2 i kan3 jako "synchronizator", sprawdzone dla 
odbiornikow Fr-Sky i Jeti Rex5
*/

#include <Servo.h> // dołaczenie biblioteki
Servo SerwoL;     // utworzenie obiektu do sterowania serwem 
Servo SerwoP;

byte PinRx1 = 2;  // sygnal kan1 podlaczony do Pin2
byte PinRx2 = 3;  // sygnal kan2 podlaczony do Pin3
byte PinRx3 = 4;  // sygnal kan3 podlaczony do Pin4
  
int PPM2 = 1500;     // zmienna na dlugosc impulsu PPM kan2 w mikrosek
int PPM3 = 1500;     // zmienna na dlugosc impulsu PPM kan3 w mikrosek
byte Rx1 = 0;
byte k=0;

int M2=5;
int M3=5;
unsigned int Tout = 25000; //timeout 25msec dla detekcji PPM
int Licz = 0;       //  zmienne pozwalajace opcjonalnie drukowac
int LiczMax = 20;   //* co 20 impuls PPM1

int NL = 1360;      // dug. imp. dla Neutrum_Lewy
int NP = 1415;      // dug. imp. dla Neutrum_Prawy

int PL = 1200;      // dug. imp. ponizej neutrum 
int PH = 1800;      // dug. imp. powyzej neutrum

void setup()
{
  //Serial.begin(57600);   // ustaw opcjonalnie predkosc transmisji
  SerwoP.attach(8);   // Pin8 obiektu "SerwoP"
  SerwoL.attach(9);   // Pin9 obiektu "SerwoL"
  pinMode(PinRx1,INPUT); // ustaw PinRx1 jako wejscie
  pinMode(PinRx2,INPUT); // ustaw PinRx2 jako wejscie
  pinMode(PinRx3,INPUT); // ustaw PinRx3 jako wejscie

  SerwoP.writeMicroseconds(NP); //ustaw prawe serwo w neutrum
  SerwoL.writeMicroseconds(NL); //ustaw lewe serwo w neutrum
}


void loop() {
 
  Rx1=digitalRead(PinRx1);  // czytaj na zmiane kan2 lub kan3
                            // jesli zaden z nich nie jest wysoki 
  if (Rx1==0)
  {
   k += 1;
   if (k==1)
   {
    PPM2=pulseIn(PinRx2,HIGH,Tout);
   }
   else
   {
    PPM3=pulseIn(PinRx3,HIGH,Tout);    
    k=0;  
   }  
  }

 M2 = map(PPM2, 1000, 2000, 0, 9); // translacja dlugosci impulsu PPM
 M3 = map(PPM3, 1000, 2000, 0, 9); //* 1-2msec na zakres 0-9

 if (M3==4)  { // jesli kan3 neutrum to obrót
 
  if (M2==4) {
  SerwoP.writeMicroseconds(NP);
  SerwoL.writeMicroseconds(NL);
  }
  if (M2<4) {
  SerwoP.writeMicroseconds(PH);
  SerwoL.writeMicroseconds(PH);
  }
  if (M2>4) {
  SerwoP.writeMicroseconds(PL);
  SerwoL.writeMicroseconds(PL);
  }
  
 }    //if (M3==4)
 
 
 if (M3>4)  { // jesli kan3 do przodu
 
  if (M2==4) {
  SerwoP.writeMicroseconds(PL);
  SerwoL.writeMicroseconds(PH);
  }
  if (M2<4) {
  SerwoP.writeMicroseconds(NP);
  SerwoL.writeMicroseconds(PH);
  }
  if (M2>4) {
  SerwoP.writeMicroseconds(PL);
  SerwoL.writeMicroseconds(NL);
  }
 }    //if (M3>4)
 

if (M3<4)  { // jesli kan3 do do tylu
 
  if (M2==4) {
  SerwoP.writeMicroseconds(PH);
  SerwoL.writeMicroseconds(PL);
  }
  if (M2<4) {
  SerwoP.writeMicroseconds(NP);
  SerwoL.writeMicroseconds(PL);
  }
  if (M2>4) {
  SerwoP.writeMicroseconds(PH);
  SerwoL.writeMicroseconds(NL);
  }
 }    //if (M3<4) 
 
 delay(10);
 
 /* //opcjonalne drukowanie do testow
 
 Licz += 1;                 // zwieksz licznik impulsow o 1 
 if (Licz>LiczMax) {        // drukuj wartosc co n-ty impuls

  //Serial.print(PPM2);
  Serial.print(M2);
  Serial.print(";  ");
  //Serial.print(PPM3);
  Serial.print(M3);
  Serial.println(";  ");
  Licz = 0;
 }

 */ //opcjonalne drukowanie do testow
 
}
